package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type SuspendServerLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewSuspendServerLogic(ctx context.Context, svcCtx *svc.ServiceContext) *SuspendServerLogic {
	return &SuspendServerLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *SuspendServerLogic) SuspendServer(req *types.SuspendServerReq) (resp *types.SuspendServerResp, err error) {
	// todo: add your logic here and delete this line
	SuspendServerReq := &openstack.SuspendServerReq{}
	err = copier.CopyWithOption(SuspendServerReq, req, copier.Option{Converters: utils.Converters})
	SuspendServerResp, err := l.svcCtx.OpenstackRpc.SuspendServer(l.ctx, SuspendServerReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&SuspendServerResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &SuspendServerResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
